# wideLearning

# Минимальные требования к аппаратной части:
* Операционная система: Windows 7 или выше (64-bit), Linux (64-bit)
* Оперативная память: не менее 2 GB
* Процессор: двухъядерный с частотой 1.6 GHz или выше
* Свободное место на жестком диске: не менее 2 GB

# Направления прикладного использования:
1. Компьютерное зрение. Упрощение архитектур сверточных нейронных сетей для задач классификации и распознавания изображений, сегментации и детектирования объектов.
2. Медицинская диагностика. Оптимизация нейронных сетей, используемых при анализе изображений и сигналов, полученных от медицинских приборов. Может использоваться для обнаружения и классификации заболеваний.
3. Рекомендательные системы. Может использоваться для классификации на основе некоторых признаков контента и выдачи персонализированных рекомендаций.
4. Развертывание моделей нейронных сетей на устройствах малой вычислительной мощности, например, мобильные гаджеты (смартфоны/планшеты), встраиваемые устройства (промышленные контроллеры/смарт-устройства) и т.п.

# Установка
pip install widelearning

# Импорт библиотеки
import widelearning as wdl 

