# -*- coding: utf-8 -*-
from setuptools import setup

modules = \
['widelearning']
setup_kwargs = {
    'name': 'widelearning',
    'version': '0.8.1',
    'description': 'Library for searching the optimal neural network architecture',
    'long_description': '# wideLearning\n\n# Минимальные требования к аппаратной части:\n* Операционная система: Windows 7 или выше (64-bit), Linux (64-bit)\n* Оперативная память: не менее 2 GB\n* Процессор: двухъядерный с частотой 1.6 GHz или выше\n* Свободное место на жестком диске: не менее 2 GB\n\n# Направления прикладного использования:\n1. Компьютерное зрение. Упрощение архитектур сверточных нейронных сетей для задач классификации и распознавания изображений, сегментации и детектирования объектов.\n2. Медицинская диагностика. Оптимизация нейронных сетей, используемых при анализе изображений и сигналов, полученных от медицинских приборов. Может использоваться для обнаружения и классификации заболеваний.\n3. Рекомендательные системы. Может использоваться для классификации на основе некоторых признаков контента и выдачи персонализированных рекомендаций.\n4. Развертывание моделей нейронных сетей на устройствах малой вычислительной мощности, например, мобильные гаджеты (смартфоны/планшеты), встраиваемые устройства (промышленные контроллеры/смарт-устройства) и т.п.\n\n# Установка\npip install widelearning\n\n# Импорт библиотеки\nimport widelearning as wdl \n\n',
    'author': 'Brinkinvision',
    'author_email': 'brinkinvision@gmail.com',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'py_modules': modules,
    'python_requires': '>=3.6,<4.0',
}


setup(**setup_kwargs)
